//+------------------------------------------------------------------+
//|   #SpudFibo.mq4 - downloaded from ultimaforex.com
//+------------------------------------------------------------------+
#property  indicator_chart_window

extern string note1 = "Fibonacci colors";
extern color UpperFiboColor = Green;
extern color MainFiboColor = RoyalBlue;
extern color LowerFiboColor = Blue;
extern string note2 = "Draw main Fibonacci lines?";
extern bool  InnerFibs = true;

double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("FiboUpM");
   ObjectDelete("FiboDnM");
   ObjectDelete("FiboInM");
   return(0);
}


//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(ObjectFind("FiboUpM") == -1)
		ObjectCreate("FiboUpM",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("FiboUpM",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboUpM",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboUpM",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("FiboUpM",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("FiboUpM",OBJPROP_LEVELCOLOR,UpperFiboColor);
   ObjectSet("FiboUpM",OBJPROP_FIBOLEVELS,13);
   ObjectSet("FiboUpM",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboUpM",0,"(100.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboUp",1,"(123.6%) -  %$"); 
   ObjectSet("FiboUpM",OBJPROP_FIRSTLEVEL+2,0.272);	ObjectSetFiboDescription("FiboUpM",2,"(127.2%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboUp",3,"(150.0%) -  %$"); 
   ObjectSet("FiboUpM",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboUpM",4,"(161.8%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboUp",5,"(176.4%) -  %$"); 
   ObjectSet("FiboUpM",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboUpM",6,"(200.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+7,1.236);	ObjectSetFiboDescription("FiboUp",7,"(223.6%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+8,1.500);	ObjectSetFiboDescription("FiboUp",8,"(250.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+9,1.618);	ObjectSetFiboDescription("FiboUp",9,"(261.8%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+10,2.000);	ObjectSetFiboDescription("FiboUp",10,"(300.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+11,2.500);	ObjectSetFiboDescription("FiboUp",11,"(350.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+12,3.000);	ObjectSetFiboDescription("FiboUp",12,"(400.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+13,3.500);	ObjectSetFiboDescription("FiboUp",13,"(450.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_FIRSTLEVEL+14,4.000);	ObjectSetFiboDescription("FiboUp",14,"(500.0%) -  %$"); 
   //ObjectSet("FiboUp",OBJPROP_RAY,false);
   //ObjectSet("FiboUp",OBJPROP_BACK,true);

	if(ObjectFind("FiboDnM") == -1)
		ObjectCreate("FiboDnM",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("FiboDnM",OBJPROP_TIME2, StartTime);
		ObjectSet("FiboDnM",OBJPROP_TIME1, StartTime);
		ObjectSet("FiboDnM",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("FiboDnM",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("FiboDnM",OBJPROP_LEVELCOLOR,LowerFiboColor); 
   ObjectSet("FiboDnM",OBJPROP_FIBOLEVELS,19);
   ObjectSet("FiboDnM",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboDnM",0,"(0.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboDn",1,"(-123.6%) -  %$"); 
   ObjectSet("FiboDnM",OBJPROP_FIRSTLEVEL+2,0.272);	ObjectSetFiboDescription("FiboDnM",2,"(-127.2%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboDn",3,"(-150.0%) -  %$"); 
   ObjectSet("FiboDnM",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboDnM",4,"(-161.8%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboDn",5,"(-176.4%) -  %$"); 
   ObjectSet("FiboDnM",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboDnM",6,"(-200.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+7,1.236);	ObjectSetFiboDescription("FiboDn",7,"(-223.6%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+8,1.382);	ObjectSetFiboDescription("FiboDn",8,"(-238.2%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+9,1.500);	ObjectSetFiboDescription("FiboDn",9,"(-250.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+10,1.618);	ObjectSetFiboDescription("FiboDn",10,"(-261.8%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+11,1.764);	ObjectSetFiboDescription("FiboDn",11,"(-176.4%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+12,2.000);	ObjectSetFiboDescription("FiboDn",12,"(-200.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+13,2.500);	ObjectSetFiboDescription("FiboDn",13,"(-250.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+14,3.000);	ObjectSetFiboDescription("FiboDn",14,"(-300.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+15,3.500);	ObjectSetFiboDescription("FiboDn",15,"(-350.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+16,4.000);	ObjectSetFiboDescription("FiboDn",16,"(-400.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+17,4.500);	ObjectSetFiboDescription("FiboDn",17,"(-450.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_FIRSTLEVEL+18,5.000);	ObjectSetFiboDescription("FiboDn",18,"(-500.0%) -  %$"); 
   //ObjectSet("FiboDn",OBJPROP_RAY,false);
   //ObjectSet("FiboDn",OBJPROP_BACK,true);

	if(InnerFibs)
	{
		if(ObjectFind("FiboInM") == -1)
			ObjectCreate("FiboInM",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_W1*60,LoPrice);
		else
		{
			ObjectSet("FiboInM",OBJPROP_TIME2, StartTime);
			ObjectSet("FiboInM",OBJPROP_TIME1, StartTime+PERIOD_W1*60);
			ObjectSet("FiboInM",OBJPROP_PRICE1,HiPrice);
			ObjectSet("FiboInM",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("FiboInM",OBJPROP_LEVELCOLOR,MainFiboColor); 
   	ObjectSet("FiboInM",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+0,0.0);	ObjectSetFiboDescription("FiboInM",0,"MLow (0.0) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+1,0.236);	ObjectSetFiboDescription("FiboInM",1,"(23.6) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("FiboInM",2,"(38.2) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("FiboInM",3,"(50.0) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("FiboInM",4,"(61.8) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+5,0.764);	ObjectSetFiboDescription("FiboInM",5,"(76.4) -  %$"); 
   	ObjectSet("FiboInM",OBJPROP_FIRSTLEVEL+6,1.000);	ObjectSetFiboDescription("FiboInM",6,"MHigh (100.0) -  %$"); 
      ObjectSet("FiboInM",OBJPROP_RAY,true);
   	ObjectSet("FiboInM",OBJPROP_BACK,true);
   }
   else
	   ObjectDelete("FiboInM");
}

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_MN1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_MN1,shift);
	LoPrice		= iLow (NULL,PERIOD_MN1,shift);
	StartTime	= iTime(NULL,PERIOD_MN1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_MN1,shift));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_MN1,shift));
	}

	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

